/* scroller.java
 * 
 * Version 1.0
 * Copyright(C) 2001 by Seppo Tiainen
 *
 * E-mail: seppo.tiainen@welho.com
 * WWW: http://koti.mbnet.fi/heppu2
 *
 */

import java.awt.*;
import java.applet.*;
import java.awt.image.PixelGrabber; 

public class scroller extends Applet implements Runnable {
Thread thread=null;
//-------------------------------------------------------------------------
int w,h;
Image offimage;
Graphics offg;
//-------------------------------------------------------------------------

String teksti="    http://koti.mbnet.fi/heppu2    ";

FontMetrics fm;

int leveys;
int intTeksti[];

Image talo;

public void initFontit() {
	Font fontti=new Font("Arial",Font.PLAIN,14);

	Image letterImage=createImage(20,20);
	Graphics letterg=letterImage.getGraphics();
	letterg.setFont(fontti);
	fm=letterg.getFontMetrics();

	leveys=fm.stringWidth(teksti);
	intTeksti=new int[20*leveys];
	
	letterImage=createImage(leveys,20);
	letterg=letterImage.getGraphics();
	letterg.setFont(fontti);
	fm=letterg.getFontMetrics();
			
	letterg.setColor(Color.black);
	letterg.fillRect(0,0,leveys,20);
	letterg.setColor(Color.blue);
	letterg.drawString(teksti,0,14);

		PixelGrabber pg=new PixelGrabber(letterImage,0,0,leveys,20,intTeksti,0,leveys);
		boolean done=false;
		do {
			try {
				done=pg.grabPixels(500);
			} catch(InterruptedException e) {}
		} while(!done);
}

//------------------------------------------------------------------------

double rx=0,rxold=0,
	ry=0,ryold=0;

int xkerroin=5,ykerroin=5;
double xinc=0.02, yinc=0.03;

Color vari;

int c1=0,c2=0;
double s=0;

public void scroll() {
	int x,y;
	c2=c1;
	s=Math.PI;
	for(int i=0;i<(int)(2*Math.PI/0.05);i++) {
		s+=0.05;
		if(c2>=leveys) c2=0;		
		for(int j=0;j<20;j++) {
			if(intTeksti[c2+j*leveys]!=-16777216) {
				vari=new Color(intTeksti[c2+j*leveys]);
				offg.setColor(vari);
	
				x=(int)(w/2+Math.sin(s)*(j+20)*4);
				y=(int)(h/2+Math.cos(s)*(j+20)*4);

				offg.drawOval(x,y,6,6);
			}
		}
		c2++;
	}
	c1++;
	if(c1>=leveys) c1=0;
}

//-------------------------------------------------------------------------

public void init() { 
	w=getSize().width;
	h=getSize().height;

	offimage=createImage(w,h);
	offg=offimage.getGraphics();

	MediaTracker tracker=new MediaTracker(this); 
	talo=getImage(getCodeBase(),"bg.gif");
	tracker.addImage(talo,0);  	
	try {
		tracker.waitForID(0);
	} 
	catch(InterruptedException e) {}	

	if(getParameter("TEKSTI")!=null) teksti=getParameter("TEKSTI");
	initFontit();
}

public void update(Graphics g) {
	scroll();
	g.drawImage(offimage,0,0,null);

	offg.setColor(Color.white);
	offg.fillRect(0,0,w,h);
	offg.drawImage(talo,0,0,null);
}


public void start() { 
	if(thread==null) { 
		thread=new Thread(this); 
		thread.start(); 
	}	 
} 
 
public void stop() { 
	if(thread!=null) { 
		thread.stop(); 
		thread=null; 
	} 
} 
 
public void run() { 
	while(true) { 
		repaint(); 
		try { 
			thread.sleep(50); 
		} 
		catch(InterruptedException e) {} 
	} 
} 

public void paint(Graphics g) {
	g.drawString("hep",50,50);
}

public String getAppletInfo() {
	return("seppo.tiainen@welho.com");
}

}


